/*
    PIP - Platform Independent Primitives
    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "piclientserver_client.h"

#include "piclientserver_server.h"
#include "piethernet.h"


void PIClientServer::ServerClient::createForServer(Server * parent, PIEthernet * tcp_) {
	tcp = tcp_;
	tcp->setParameter(PIEthernet::KeepConnection, false);
	init();
	CONNECTL(tcp, disconnected, ([this, parent](bool) { parent->clientDisconnected(this); }));
}


PIClientServer::Client::Client() {
	tcp = new PIEthernet(PIEthernet::TCP_Client);
	tcp->setParameter(PIEthernet::KeepConnection, true);
	own_tcp = true;
	init();
}


PIClientServer::Client::~Client() {
	if (tcp) tcp->setDebug(false);
	close();
	stopAndWait();
}


void PIClientServer::Client::connect(PINetworkAddress addr) {
	if (!tcp || !own_tcp) return;
	close();
	tcp->connect(addr, true);
	tcp->startThreadedRead();
}
